      subroutine wlic2d(f,ux,uy,t,dt,dx,dy)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     THINC/WLIC sample code version 1.
!     Author: Kensuke YOKOI
!     Email: kensuke@kensuke.biz
!     Date: Sept. 10, 2006  
!
!     f(i,j): VOF function at (i,j)
!     ux(i,j): x-component of the velocity at (i-1/2,j)
!     uy(i,j): y-component of the velocity at (i,j-1/2)
!     t,dt,dx,dy
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      include 'param.h'
      real*8 f(NX,NY)           
      real*8 ux(NX,NY),uy(NX,NY)
      real*8 t,dt,dx,dy

      real*8 f1(NX,NY) 
      real*8 f1x(NX),ux1(NX)    ! for 1D solver
      real*8 f1y(NY),uy1(NY)    ! for 1D solver
      real*8 nx1(NX,NY),ny1(NX,NY) ! normal vector
      real*8 n1(NX,2),n2(NY,2)  ! normal vector for 1D solver
      integer i,j

      do j=1,NY
      do i=1,NX
         f1(i,j)=f(i,j)
      end do
      end do


cccccc   For x direction   cccccccc
      call normal2d(f,nx1,ny1,dx,dy)
      do j=1,NY
         do i=1,NX
            f1x(i) = f(i,j)
            ux1(i) = ux(i,j)
            n1(i,1)= nx1(i,j)
            n1(i,2)= ny1(i,j)
         end do
         call wlic1d4md(f1x,ux1,n1,dt,dx,NX,1,2)
         do i=2,NX-1 ! df/dt=f div u
            f(i,j) = f1x(i)+f1(i,j)*(ux(i+1,j)-ux(i,j))/dx*dt
c            f(i,j) = f1x(i)/(1.0d0-(ux(i+1,j)-ux(i,j))/dx*dt)
         end do
      end do
cccccc   For y direction   cccccccc
      call normal2d(f,nx1,ny1,dx,dy)
      do i=1,NX
         do j=1,NY
            f1y(j) = f(i,j)
            uy1(j) = uy(i,j)
            n2(j,1)= nx1(i,j)
            n2(j,2)= ny1(i,j)
         end do
         call wlic1d4md(f1y,uy1,n2,dt,dy,NY,2,2)
         do j=2,NY-1 ! df/dt=f div u
            f(i,j) = f1y(j)+f1(i,j)*(uy(i,j+1)-uy(i,j))/dy*dt
         end do
      end do


      return
      end

